/*

Make Descriptive Stat Table (Table1 and 2)

*/

version 17

if ("`1'"==""){
	local dataset Dataset_for_DesStat
}
else{
	local dataset `1'
}

use `dataset'.dta, clear

cap mkdir "Table"

// ssc install table1

* Assigning "." to a variable with a missing value flag
local miss_var abdc vis_rt hear_1k_rt hear_1k_lt hear_4k_rt hear_4k_lt ast alt gtp bld_time cbs fbs hba1c hdl_c ldl_c ftg ctg hgb rbc smk_int smk_year

foreach x of local miss_var {
	replace `x' = . if `x'_miss == 1
} 

* If no smoking, change the number of cigarettes smoked and year of smoking to the missing values.
replace smk_int = . if smk==0 | smk==1
replace smk_year = . if smk==0


* Making Table 1
table1, by(fy_bin) vars(sex cat \ age contn %2.1f \ clin_grp cat /// 個人背景 // Personal Characteristics
	\ smk cat \ smk_int contn %2.1f \ smk_year contn %2.1f /// 喫煙 // Smoking status
	\ sbp contn %2.1f \ dbp contn %2.1f /// 血圧 // Blood pressure
	\ bmi contn %2.1f \ abdc contn %2.1f /// 測定 // Measurement
	\ vis_rt_bin bin \ vis_lt_bin bin /// 視力 0.6未満 // vision lower than 0.6
	\ hear_1k_rt bin \ hear_1k_lt bin \ hear_4k_rt bin \ hear_4k_lt bin /// 聴力 // Hearing test
	 \ phyexam bin \ ecg bin \ chest bin /// 理学所見 // Physical examination
	\ urin_bld cat \ urin_pro cat \ urin_sug cat /// 尿検査 // Urinalysis
	\ hgb contn %2.1f \ rbc contn %2.1f /// 貧血検査 // Anemia 
	\ ast contn %2.1f \ alt contn %2.1f \ gtp contn %2.1f /// 肝機能 // Liver enzyme
	\ ldl_c contn %2.1f \ hdl_c contn %2.1f \ ftg contn %2.1f \ ctg contn %2.1f /// 脂質 // Blood lipid
	\ hba1c contn %2.1f \ fbs contn %2.1f \ cbs contn %2.1f /// 血糖 // blood sugar
	\ pres_bs bin \ pres_tg bin \ pres_bp bin /// 治療歴 // history of medical treatment
	\ outcome bin) ///
	plusminus cmis
	* plusminus cmis saving(./Table/Result_Table1`2'.xls, replace)

* Making missing table 
misstable sum if fy_bin==0
misstable sum if fy_bin==1

exit
