/*

Draw Graphs (Figure2 and 3)

*/

* X-axis = Age
* Y-axis = tau
* Scatter-Plot

if ("`1'"==""){
	local dataset Dataset_xlearn
}
else{
	local dataset `1'
}
cap cwf default
use `dataset', clear

set scheme white_tableau
cap mkdir Graph

histogram tau, start(-0.9625) width(0.025) name(histogram, replace) xtitle("CATE") ytitle("Percent") percent 
graph save "histogram" "./Graph/Fig3_hist`2'.gph", replace
graph export "./Graph/Fig3_hist`2'.pdf", as(pdf) name("histogram") replace


twoway ///
	scatter tau age, mcolor(%10) msize(small) jitter(10 10) || ///
	lowess   tau age if clin_grp==0 || ///
	lowess  tau age if clin_grp==1 || ///
	lowess  tau age if clin_grp==2 || ///
	lowess  tau age if clin_grp==3,   ///
	legend(order(2 3 4 5) label(2 "Administrative divsion") label(3 "Research division") label(4 "Medical devision") label(5 "Intensive Care division")) ///
	xtitle("Age") ytitle("CATE") name(scatter, replace)
	
graph save "scatter" "./Graph/Fig4_scatter`2'.gph", replace
graph export "./Graph/Fig4_scatter`2'.pdf", as(pdf) name("scatter") replace
