* Run X-learner optimized for this study
program define xlearner

/***** ***** ***** ***** ***** ***** ***** ***** ***** ***** 
*
* Stage 1. the Estimation of Response function
* Defining the best model
*
***** ***** ***** ***** ***** ***** ***** ***** ***** ****/

* model for Unexposed group using X0
local model_X0 sex i.clin crit c.age##c.age c.bmi##c.bmi c.abdc##c.abdc hear_1k_rt hear_1k_lt hear_4k_rt hear_4k_lt c.sbp##c.sbp c.dbp##c.dbp c.sbp#c.dbp urin_pro urin_bld ast alt gtp fbs cbs hba1c c.hdl_c##c.hdl_c c.ldl_c##c.ldl_c ftg ctg c.hgb##c.hgb rbc ecg1 chest1 smk c.smk_int##c.smk_int c.smk_year##c.smk_int pres_tg pres_bp cbs_miss fbs_miss ftg_miss smk_int_miss urin_pro_bin c.bmi#c.age c.age#c.abdc c.ast#c.alt sex#c.abdc sex#c.hba1c

* model for Exposed group using X1
local model_X1 sex i.clin crit c.age##c.age c.bmi##c.bmi c.abdc##c.abdc hear_1k_rt hear_1k_lt hear_4k_rt hear_4k_lt c.sbp##c.sbp c.dbp##c.dbp c.sbp#c.dbp urin_pro urin_bld ast alt gtp fbs cbs hba1c c.hdl_c##c.hdl_c c.ldl_c##c.ldl_c ftg ctg c.hgb##c.hgb rbc ecg1 chest1 smk c.smk_int##c.smk_int c.smk_year##c.smk_int pres_tg pres_bp cbs_miss fbs_miss ftg_miss smk_int_miss urin_pro_bin c.bmi#c.age c.age#c.abdc c.ast#c.alt sex#c.abdc sex#c.hba1c

/***** ***** ***** ***** ***** ***** ***** ***** ***** ***** 
*
* Stage 2-1. Calculate the Imputed Treatment Effect for each person.
*
***** ***** ***** ***** ***** ***** ***** ***** ***** ****/

* tau_0 = M1(X0) - Y0
logistic outcome `model_X1' if fy_bin==1
predict double m1_x0_pred, pr
gen double tau_0 = m1_x0_pred - outcome if fy_bin==0

///// Evaluation of M1 /////
roctab outcome m1_x0_pred if fy_bin==1
global AUC_M1 = `r(area)'


* tau_1 = Y1 - M0(X1)
logistic outcome `model_X0' if fy_bin==0
predict double m0_x1_pred, pr
gen double tau_1 = outcome - m0_x1_pred if fy_bin==1

///// Evaluation of M0 /////
roctab outcome m0_x1_pred if fy_bin==0
global AUC_M0 = `r(area)'

su tau*

forvalues i = 0/1 {
	replace tau_`i' =  0.999999999999 if float(tau_`i') == 1
	replace tau_`i' = -0.999999999999 if float(tau_`i') == -1
}

su tau*


compress


/***** ***** ***** ***** ***** ***** ***** ***** ***** ***** 
*
* Stage 2-2. Define a model to predict tau_0 and tau_1
*
***** ***** ***** ***** ***** ***** ***** ***** ***** ****/


* model for predict tau_0 using X0
local model_tau0 sex i.clin crit c.age##c.age c.bmi##c.bmi c.abdc##c.abdc hear_1k_rt hear_1k_lt hear_4k_rt hear_4k_lt c.sbp##c.sbp c.dbp##c.dbp c.sbp#c.dbp urin_pro urin_bld ast alt gtp fbs cbs hba1c c.hdl_c##c.hdl_c c.ldl_c##c.ldl_c ftg ctg c.hgb##c.hgb rbc ecg1 chest1 smk c.smk_int##c.smk_int c.smk_year##c.smk_int pres_tg pres_bp cbs_miss fbs_miss ftg_miss smk_int_miss urin_pro_bin c.bmi#c.age c.age#c.abdc c.ast#c.alt sex#c.age

* model for predict tau_1 using X1
local model_tau1 sex i.clin crit c.age##c.age c.bmi##c.bmi c.abdc##c.abdc /*hear_1k_rt hear_1k_lt*/ hear_4k_rt hear_4k_lt c.sbp##c.sbp c.dbp##c.dbp c.sbp#c.dbp urin_pro /*urin_bld*/ ast alt gtp fbs cbs hba1c c.hdl_c##c.hdl_c c.ldl_c##c.ldl_c ftg ctg c.hgb##c.hgb rbc ecg1 chest1 smk c.smk_int##c.smk_int c.smk_year##c.smk_int pres_tg pres_bp cbs_miss fbs_miss ftg_miss smk_int_miss urin_pro_bin c.bmi#c.age c.age#c.abdc c.ast#c.alt sex#c.abdc

/***** ***** ***** ***** ***** ***** ***** ***** ***** ***** 
*
* Stage 3-1. Calculate predicted values for tau_0 and tau_1
*
***** ***** ***** ***** ***** ***** ***** ***** ***** ****/
* Do a BETA REGRESSION with the range of tau_0 and tau_1 as [0, 1].
* original tau_0 and tau_1 are [-1, +1]
gen double tau_0r = (tau_0 + 1)/2
gen double tau_1r = (tau_1 + 1)/2

* Calculate the predicted value of tau_0
betareg tau_0r `model_tau0'
predict double tau_0r_pred, cmean
gen double tau_0_pred = 2 * tau_0r_pred - 1

///// Evaluation of M2 /////
gen diff2 = (tau_0r - tau_0r_pred)^2 
su  diff2 if fy_bin==0 
global RMSE_M2 = sqrt(`r(mean)')
drop diff2


* Calculate the predicted value of tau_1
betareg tau_1r `model_tau1'
predict double tau_1r_pred, cmean
gen double tau_1_pred = 2 * tau_1r_pred - 1

///// Evaluation of M3 /////
gen diff2 = (tau_1r - tau_1r_pred)^2 
su  diff2 if fy_bin==1
global RMSE_M3 = sqrt(`r(mean)')
drop diff2

/***** ***** ***** ***** ***** ***** ***** ***** ***** ***** 
*
* Stage 3-2. Caluculate weight funcion g(x)
*
***** ***** ***** ***** ***** ***** ***** ***** ***** ****/

// <<E=0/1 is not a conditional prob since it is not determined by X>> //
local model_gx // sex i.clin crit c.age##c.age c.bmi##c.bmi c.abdc##c.abdc /*hear_1k_rt hear_1k_lt*/ hear_4k_rt hear_4k_lt c.sbp##c.sbp c.dbp##c.dbp c.sbp#c.dbp urin_pro /*urin_bld*/ ast alt gtp fbs cbs hba1c c.hdl_c##c.hdl_c c.ldl_c##c.ldl_c ftg ctg c.hgb##c.hgb rbc ecg1 chest1 smk c.smk_int##c.smk_int c.smk_year##c.smk_int pres_tg pres_bp cbs_miss fbs_miss ftg_miss smk_int_miss urin_pro_bin c.bmi#c.age c.age#c.abdc c.ast#c.alt sex#c.abdc 

logistic fy_bin `model_gx'
predict gx, pr

/***** ***** ***** ***** ***** ***** ***** ***** ***** ***** 
*
* Stage 3-3. Calculation of tau 
*
***** ***** ***** ***** ***** ***** ***** ***** ***** ****/
gen tau = gx*tau_0_pred + (1-gx)*tau_1_pred

end